package sawat.tiling;

import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import java.util.Random;

import javax.swing.JComponent;
import javax.swing.JFrame;

public class Tessellation extends JComponent {
	// {ƂȂlp`
	private Polygon shape;
	// {ƂȂlp`hF
	private Color mainColor;
	// 180x]lp`hF
	private Color subColor;
	// E`F
	private Color lineColor;
	// ẼXg[N
	private BasicStroke stroke;

	/**
	 * C
	 * @param args
	 */
	public static void main(String[] args) {

		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				JFrame f = new JFrame("ʏ[U");
				f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				f.getContentPane().add(new Tessellation());
				f.setSize(400, 300);
				// f.pack();
				f.setLocationRelativeTo(null);
				f.setVisible(true);
			}
		});
	}

	/** RXgN^ */
	public Tessellation() {
		this.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				// }EXNbNŐ}ƐFω
				reflesh(!e.isShiftDown(), !e.isAltDown());
				Tessellation.this.repaint();
			}
		});
		stroke = new BasicStroke(2.0f);
		reflesh(true, true);
	}

	/**
	 * Vlp`B
	 * @return lp`PolygonIuWFNg
	 */
	private Polygon createShape() {

		int size = 150;
		Random rand = new Random();
		int[] xIdx = new int[4];
		int[] yIdx = new int[4];
		double d = 0.5 * Math.PI * rand.nextDouble();
		double d1 = Math.PI * rand.nextDouble();
		double d2 = Math.PI - d1;
		for (int i = 0; i < 4; i++) {
			final double r = rand.nextDouble();
			xIdx[i] = (int) (Math.cos(d) * (5 + size * r));
			yIdx[i] = (int) (Math.sin(d) * (5 + size * r));

			d += (i % 2 == 0) ? d1 : d2;
		}

		return new Polygon(xIdx, yIdx, 4);
	}

	/** ʏ[U̕`揈 */
	@Override
	protected void paintComponent(Graphics _g) {
		Graphics2D g = (Graphics2D) _g;
		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);

		int w = getWidth();
		int h = getHeight();
		g.setColor(Color.WHITE);
		g.fillRect(0, 0, w, h);
		g.translate(w / 2, h / 2);

		fillRepeate(g, shape);
	}

	/**
	 * }`~l߂B
	 * @param g
	 * @param s
	 */
	private void fillRepeate(Graphics2D g, Polygon s) {
		g.setStroke(stroke);

		int xd0 = s.xpoints[0] - s.xpoints[2];
		int yd0 = s.ypoints[0] - s.ypoints[2];
		int xd1 = s.xpoints[1] - s.xpoints[3];
		int yd1 = s.ypoints[1] - s.ypoints[3];

		// 180x]
		Shape rev = AffineTransform.getQuadrantRotateInstance(2)
				.createTransformedShape(s);
		// Ήӂׂ荇ʒu֕sړ
		rev = AffineTransform.getTranslateInstance(s.xpoints[0] + s.xpoints[1],
				s.ypoints[0] + s.ypoints[1]).createTransformedShape(rev);

		int ni = 1 + repeatCount(getWidth(), getHeight(), xd0, yd0) / 2;
		int nj = 1 + repeatCount(getWidth(), getHeight(), xd1, yd1) / 2;
		for (int i = -ni; i <= ni; i++) {
			for (int j = -nj; j <= nj; j++) {
				Shape ss = AffineTransform.getTranslateInstance(
						xd0 * i + xd1 * j, yd0 * i + yd1 * j)
						.createTransformedShape(s);
				Shape revSS = AffineTransform.getTranslateInstance(
						xd0 * i + xd1 * j, yd0 * i + yd1 * j)
						.createTransformedShape(rev);
				g.setColor(mainColor);
				g.fill(ss);
				g.setColor(subColor);
				g.fill(revSS);
				g.setColor(lineColor);
				g.draw(ss);
			}
		}
	}

	/**
	 * JԂ񐔂߂iKɁj
	 */
	private int repeatCount(int w, int h, int xd, int yd) {
		return xd == 0 ? h / Math.abs(yd) : yd == 0 ? w / Math.abs(xd) : Math
				.max(w / Math.abs(xd), h / Math.abs(yd));
	}

	/**
	 * lp`ƐF_ĐB
	 */
	private void reflesh(boolean shp, boolean clr) {
		if(shp)shape = createShape();
		if(clr) {
		mainColor = new Color(Color.HSBtoRGB((float) Math.random(), (float) Math.random(), 1.0f));
		subColor = new Color(Color.HSBtoRGB((float) Math.random(), 0.5f, (float) Math.random()));
		lineColor = new Color(Color.HSBtoRGB((float) Math.random(),
				(float) Math.random(), (float) Math.random()));
		}
	}
}
